(ns clj-in-act.ch1
  "Introducing Clojure")

;;; 1.2 Language Basics

;;; From a semicolon to a newline is a comment.


(str "Hello, " "World!")
;; Result: "Hello, World!"
; (A Semi-colon starts a code comment which continues
; to the end of the line.)


(str "Hello from " "Clojure with " "lots of " " arguments")
;; Result: "Hello from Clojure with lots of arguments"


(+ 1 2)
;; Result: 3

(+ 1 2 3)
;; Result: 6

(+ 3 (* 4 2))
(+ 3 8)
;; Result: 11


;;; 1.3 Java Interop

;;; The `dot` operator

(. Math PI)
;; Result: 3.141592653589793

(. Math abs -3)
;; Result: 3

(. "foo" toUpperCase)
;; Result: "FOO"


Math/PI
;; Result: 3.141592653589793

(Math/abs -3)
;; Result: 3

(.toUpperCase "foo")
;; Result: "FOO"


;;; The `new` operator

(new Integer "42")
;; Result: 42

(Integer. "42")
;; Result: 42
